Bug 646500

Summary: Kickstart file is not generated when no space for install.img
Product: [Fedora] Fedora Reporter: James Cassell <fedoraproject>
Component: preupgradeAssignee: Richard Hughes <rhughes>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: low    
Version: 12CC: awilliam, dan, ericlake, fedora, jlaska, kparal, martin, rhughes, richard
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: preupgrade-1.1.8-1.fc12.1 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 587627 Environment:
Last Closed: 2010-11-03 07:45:22 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On: 587627    
Bug Blocks: 507681    

Description James Cassell 2010-10-25 09:51:27 EDT
When running preupgrade-cli on Fedora 12, trying to upgrade to Fedora 13, I get the "kickstart not found" error as in the cloned bug report below.  There is a missing space before "stage2="

Version: preupgrade-1.1.7-1.fc12.noarch

+++ This bug was initially created as a clone of Bug #587627 +++

Created attachment 410391 [details]
screenshot

Description of problem:
Followed
https://fedoraproject.org/wiki/Test_Day:2010-04-29_Preupgrade
https://fedoraproject.org/wiki/QA:Testcase_Preupgrade_low_/boot_disk_space_to_download

When there is not space for install.img, preupgrade will offer to download it later, but it won't generate any kickstart file.

See screenshot.

Version-Release number of selected component (if applicable):
preupgrade-1.1.5-1.fc12.noarch

How reproducible:
always

--- Additional comment from jlaska@redhat.com on 2010-04-30 16:17:19 EDT ---

Proposing as a F13Blocker.  Since running low on /boot disk space is common, this issue came up multiple times during the test day.  I'd like to propose moving the kickstart generation into it's own try/except block so that it can still be written to disk.

--- Additional comment from jlaska@redhat.com on 2010-05-04 10:41:53 EDT ---

Created attachment 411323 [details]
preupgrade.patch - move kickstart generation before install.img download

I'm testing the attached patch as we speak.  This patch only fixes preupgrade, preupgrade-cli would need a similar change I gather.


--- Additional comment from ericlake@gmail.com on 2010-05-06 18:23:26 EDT ---

I worked with jlaska today on this issue and ran some tests on a fresh install of Fedora 12 x86. I did an install selecting all of the defaults except in the area of partitioning. I changed the /boot partition from the default 200mb to 1024mb.

Once the system was fully updated to the latest F12 patch level I installed both http://people.freedesktop.org/~hughsient/fedora/13/i386/preupgrade-1.1.6-0.10.fc13.noarch.rpm and http://kojipkgs.fedoraproject.org/packages/python-urlgrabber/3.9.1/4.1.fc12/noarch/python-urlgrabber-3.9.1-4.1.fc12.noarch.rpm

After these two packages were updated I ran preupgrade as root. The process was very smooth after that. Following is the output that preupgrade generated:

[root@oneil ~]# preupgrade
Loaded plugins: blacklist, whiteout
No plugin match for: rpm-warm-cache
No plugin match for: remove-with-leaves
No plugin match for: auto-update-debuginfo
preupgrade-main (mirrorlist) 
  url: http://mirrors.fedoraproject.org/mirrorlist?repo=fedora-13&arch=$basearch
  now: http://mirrors.fedoraproject.org/mirrorlist?repo=fedora-13&arch=i386
preupgrade (mirrorlist) 
  url: http://mirrors.fedoraproject.org/mirrorlist?path=pub/fedora/linux/development/13/$basearch/os
  now: http://mirrors.fedoraproject.org/mirrorlist?path=pub/fedora/linux/development/13/i386/os
unknown metadata being downloaded: repomdG9KuvBtmp.xml
unknown metadata being downloaded: MEMORY
Fetched treeinfo from http://mirrordenver.fdcservers.net/fedora/development/13/i386/os//.treeinfo
treeinfo timestamp: Thu May  6 10:16:56 2010
unknown metadata being downloaded: MEMORY
unknown metadata being downloaded: MEMORY
Downloading 760.1MB
Available disk space for /var/cache/yum/preupgrade: 61.5GB
Upgrade requires 500.0MB
Available disk space for /usr: 60.8GB
Kernel requires 26.0MB
Available disk space for /boot: 716.8MB
unknown metadata being downloaded: repomdVrUGr2tmp.xml
Generating metadata for preupgrade repo
DEBUG /sbin/grubby --title="Upgrade to Fedora 13 (Branch)" --remove-kernel="/boot/upgrade/vmlinuz" --add-kernel="/boot/upgrade/vmlinuz" --initrd="/boot/upgrade/initrd.img" --args="preupgrade repo= hd::/var/cache/yum/preupgrade  ks= hd:UUID=54bb5aef-5b7a-4af8-b4c2-581ac7bc85cb:/upgrade/ks.cfg stage2= hd:UUID=54bb5aef-5b7a-4af8-b4c2-581ac7bc85cb:/upgrade/install.img"

jlaska asked what the grub.conf looked like once it was complete. Following is the /boot/grub/grub.conf that was generated:

# grub.conf generated by anaconda
#
# Note that you do not have to rerun grub after making changes to this file
# NOTICE:  You have a /boot partition.  This means that
#          all kernel and initrd paths are relative to /boot/, eg.
#          root (hd0,0)
#          kernel /vmlinuz-version ro root=/dev/mapper/vg_oneil-LogVol00
#          initrd /initrd-[generic-]version.img
#boot=/dev/sda
default=1
timeout=0
splashimage=(hd0,0)/grub/splash.xpm.gz
hiddenmenu
title Upgrade to Fedora 13 (Branch)
	kernel /upgrade/vmlinuz preupgrade repo= hd::/var/cache/yum/preupgrade ks= hd:UUID=54bb5aef-5b7a-4af8-b4c2-581ac7bc85cb:/upgrade/ks.cfg stage2= hd:UUID=54bb5aef-5b7a-4af8-b4c2-581ac7bc85cb:/upgrade/install.img
	initrd /upgrade/initrd.img
title Fedora (2.6.32.11-99.fc12.i686.PAE)
	root (hd0,0)
	kernel /vmlinuz-2.6.32.11-99.fc12.i686.PAE ro root=/dev/mapper/vg_oneil-LogVol00  LANG=en_US.UTF-8 SYSFONT=latarcyrheb-sun16 KEYBOARDTYPE=pc KEYTABLE=us rhgb quiet
	initrd /initramfs-2.6.32.11-99.fc12.i686.PAE.img
title Fedora (2.6.31.5-127.fc12.i686.PAE)
	root (hd0,0)
	kernel /vmlinuz-2.6.31.5-127.fc12.i686.PAE ro root=/dev/mapper/vg_oneil-LogVol00  LANG=en_US.UTF-8 SYSFONT=latarcyrheb-sun16 KEYBOARDTYPE=pc KEYTABLE=us rhgb quiet
	initrd /initramfs-2.6.31.5-127.fc12.i686.PAE.img

The thing that seemed odd to jlaska and I was the spaces in the kernel line. For instance repo= hd::

Following his advice I edited the grub.conf file to add 

title Upgrade to Fedora 13 (Branch) -- MODIFIED
	kernel /upgrade/vmlinuz preupgrade repo=hd::/var/cache/yum/preupgrade ks=hd:UUID=54bb5aef-5b7a-4af8-b4c2-581ac7bc85cb:/upgrade/ks.cfg stage2=hd:UUID=54bb5aef-5b7a-4af8-b4c2-581ac7bc85cb:/upgrade/install.img
	initrd /upgrade/initrd.img

after the first F13 kernel line.

After this I rebooted the system and it booted to the F13 upgrade screens and it progressed as expected.

--- Additional comment from kparal@redhat.com on 2010-05-07 03:14:19 EDT ---

Ok, I updated to python-urlgrabber-3.9.1-4.1.fc12 and that solved that traceback. Kickstart is now generated when not enough space for install.img, good. But there are still some problems:

1. preupgrade does not require python-urlgrabber-3.9.1-4.1.fc12. It must require that, because you can't suppose the user has all packages fully updated.
2. Upgrade item in GRUB is not set as default. I have seen this for several times, it seems to appear randomly (after some preupgrade runs it is default, after some it isn't).
3. There are superfluous spaces in GRUB item, exactly as Eric Lake reported. That makes the whole process fail ("kickstart not found").

--- Additional comment from rhughes@redhat.com on 2010-05-12 11:00:17 EDT ---

(In reply to comment #12)
> 2. Upgrade item in GRUB is not set as default. I have seen this for several
> times, it seems to appear randomly (after some preupgrade runs it is default,
> after some it isn't).
> 3. There are superfluous spaces in GRUB item, exactly as Eric Lake reported.
> That makes the whole process fail ("kickstart not found").    

Different bug reports please, please don't piggy back new things onto this ticket. Thanks.


--- Additional comment from rharrison@fedoraproject.org on 2010-05-20 17:10:38 EDT ---

(In reply to comment #12)
> 3. There are superfluous spaces in GRUB item, exactly as Eric Lake reported.
> That makes the whole process fail ("kickstart not found").    

I also ran into this issue with preupgrade-1.1.6-1.fc12.  Removing the spaces in /etc/grup.conf by hand seems to have allowed the upgrade to proceed.

--- Additional comment from gronslet@gmail.com on 2010-07-20 06:54:30 EDT ---

I just want to add that I just had problems upgrading from F12 to F13 because of a *missing* space in grub.conf. I have a small /boot, and thus a http link was inserted as the stage2 parameter, but there was no space in front of the "stage2=..." keyword. Therefore, I got a message that the kickstart file could not be found. Adding a space before stage2 in grub.conf solved the problem.

(The system is upgrading now, so I cannot report the version etc, sorry)

--- Additional comment from gronslet@gmail.com on 2010-07-20 08:58:58 EDT ---

It was preupgrade-1.1.7-1.fc12.noarch.
Comment 1 Dan HorĂ¡k 2010-10-25 11:49:30 EDT
The original build of 1.1.8 failed, so I've fixed it and here it is - https://admin.fedoraproject.org/updates/preupgrade-1.1.8-1.fc12.1

I've just successfully done an upgrade of F-12 to F-14, so please test and give it karma.
Comment 2 James Laska 2010-10-26 10:09:30 EDT
(In reply to comment #1)
> The original build of 1.1.8 failed, so I've fixed it and here it is -
> https://admin.fedoraproject.org/updates/preupgrade-1.1.8-1.fc12.1
> 
> I've just successfully done an upgrade of F-12 to F-14, so please test and give
> it karma.

Tested and supplied positive karma to the proposed bodhi update.  The update resolves the reported problem.  Thanks!

This update needs more positive karma to be pushed to F-12 stable.  Can anyone running F-12 test the proposed update (see https://admin.fedoraproject.org/updates/preupgrade-1.1.8-1.fc12.1).

NOTE: preupgrade-1.1.8-1.fc12.1 was not yet available in 'updates-testing' at the time I tested.  I needed to manually download the package and install on my system.
Comment 3 Bug Zapper 2010-11-03 05:19:34 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 James Laska 2010-11-03 07:45:22 EDT
https://admin.fedoraproject.org/updates/preupgrade-1.1.8-1.fc12.1 has been pushed to stable ... I'm closing this out